'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var guessPort = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
    var ports, validPorts;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return listPorts();

          case 2:
            ports = _context.sent;
            validPorts = ports.map(function (port) {
              return port.comName;
            }).filter(function (port) {
              return PORT_GUESS_REGEX.test(port);
            });

            if (!validPorts.length) {
              _context.next = 6;
              break;
            }

            return _context.abrupt('return', validPorts.shift());

          case 6:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function guessPort() {
    return _ref.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _ = require('lodash');
var Promise = require('bluebird');

var _require = require('./nextion'),
    Nextion = _require.Nextion;

var _require2 = require('./protocol'),
    NextionProtocol = _require2.NextionProtocol;

var Serialport = require('serialport');
var listPorts = Promise.promisify(Serialport.list);

var DEFAULT_BAUD_RATE = 9600;
var PORT_GUESS_REGEX = /usb|acm|^com/i;

function openPort(opts) {
  opts = _.defaults({
    parser: Serialport.parsers.byteDelimiter([0xff, 0xff, 0xff]),
    baudRate: DEFAULT_BAUD_RATE
  }, opts);
  return new Promise(function (resolve, reject) {
    /* eslint no-new:off */
    new Serialport(opts.port, opts, function (err) {
      if (err) {
        return reject(err);
      }
      resolve(this);
    });
  });
}

exports.createConnection = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
    var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var port;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            port = void 0;


            if (_.isString(opts)) {
              opts = {
                port: opts
              };
            }

            if (!_.isString(opts.port)) {
              _context2.next = 8;
              break;
            }

            _context2.next = 5;
            return openPort(opts);

          case 5:
            port = _context2.sent;
            _context2.next = 20;
            break;

          case 8:
            if (!_.isObject(opts.port)) {
              _context2.next = 12;
              break;
            }

            port = opts.port;
            _context2.next = 20;
            break;

          case 12:
            _context2.next = 14;
            return guessPort();

          case 14:
            opts.port = _context2.sent;

            if (opts.port) {
              _context2.next = 17;
              break;
            }

            throw new Error('No suitable ports found');

          case 17:
            _context2.next = 19;
            return openPort(opts);

          case 19:
            port = _context2.sent;

          case 20:
            return _context2.abrupt('return', new Nextion(port, opts));

          case 21:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  function createConnection() {
    return _ref2.apply(this, arguments);
  }

  return createConnection;
}();

exports.Nextion = Nextion;
exports.NextionProtocol = NextionProtocol;