'use strict';

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('events'),
    EventEmitter = _require.EventEmitter;

var _require2 = require('./protocol'),
    NextionProtocol = _require2.NextionProtocol;

var _ = require('lodash');

var Nextion = function (_EventEmitter) {
  (0, _inherits3.default)(Nextion, _EventEmitter);

  function Nextion(port) {
    var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    (0, _classCallCheck3.default)(this, Nextion);

    var _this = (0, _possibleConstructorReturn3.default)(this, _EventEmitter.call(this));

    _this.port = port;
    _this.protocol = new NextionProtocol();

    if (_.isFunction(port.isOpen) && !port.isOpen()) {
      port.on('open', function () {
        _this.listen();
      });
    } else {
      _this.listen();
    }

    port.on('error', function (err) {
      _this.emit('error', err);
    });
    return _this;
  }

  Nextion.prototype.listen = function listen() {
    var _this2 = this;

    this.port.on('data', function (data) {
      var result = void 0;
      try {
        result = _this2.protocol.read(Buffer.from(data)).response().result;
        _this2.emit(result.command, result.data);
      } catch (err) {
        _this2.emit('error', err);
      }
    });
  };

  return Nextion;
}(EventEmitter);

exports.Nextion = Nextion;